// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0

package queries

import (
	"database/sql/driver"
	"fmt"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

type ContractsContentHashAlgorithm string

const (
	ContractsContentHashAlgorithmSha3512 ContractsContentHashAlgorithm = "sha3_512"
)

func (e *ContractsContentHashAlgorithm) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = ContractsContentHashAlgorithm(s)
	case string:
		*e = ContractsContentHashAlgorithm(s)
	default:
		return fmt.Errorf("unsupported scan type for ContractsContentHashAlgorithm: %T", src)
	}
	return nil
}

type NullContractsContentHashAlgorithm struct {
	ContractsContentHashAlgorithm ContractsContentHashAlgorithm
	Valid                         bool // Valid is true if ContractsContentHashAlgorithm is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullContractsContentHashAlgorithm) Scan(value interface{}) error {
	if value == nil {
		ns.ContractsContentHashAlgorithm, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.ContractsContentHashAlgorithm.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullContractsContentHashAlgorithm) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.ContractsContentHashAlgorithm), nil
}

type ContractsDistributionAction string

const (
	ContractsDistributionActionSubmitContract        ContractsDistributionAction = "submit_contract"
	ContractsDistributionActionSubmitAcceptSignature ContractsDistributionAction = "submit_accept_signature"
	ContractsDistributionActionSubmitRejectSignature ContractsDistributionAction = "submit_reject_signature"
	ContractsDistributionActionSubmitRevokeSignature ContractsDistributionAction = "submit_revoke_signature"
)

func (e *ContractsDistributionAction) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = ContractsDistributionAction(s)
	case string:
		*e = ContractsDistributionAction(s)
	default:
		return fmt.Errorf("unsupported scan type for ContractsDistributionAction: %T", src)
	}
	return nil
}

type NullContractsDistributionAction struct {
	ContractsDistributionAction ContractsDistributionAction
	Valid                       bool // Valid is true if ContractsDistributionAction is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullContractsDistributionAction) Scan(value interface{}) error {
	if value == nil {
		ns.ContractsDistributionAction, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.ContractsDistributionAction.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullContractsDistributionAction) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.ContractsDistributionAction), nil
}

type ContractsServiceProtocolType string

const (
	ContractsServiceProtocolTypePROTOCOLTCPHTTP11 ContractsServiceProtocolType = "PROTOCOL_TCP_HTTP_1.1"
	ContractsServiceProtocolTypePROTOCOLTCPHTTP2  ContractsServiceProtocolType = "PROTOCOL_TCP_HTTP_2"
)

func (e *ContractsServiceProtocolType) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = ContractsServiceProtocolType(s)
	case string:
		*e = ContractsServiceProtocolType(s)
	default:
		return fmt.Errorf("unsupported scan type for ContractsServiceProtocolType: %T", src)
	}
	return nil
}

type NullContractsServiceProtocolType struct {
	ContractsServiceProtocolType ContractsServiceProtocolType
	Valid                        bool // Valid is true if ContractsServiceProtocolType is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullContractsServiceProtocolType) Scan(value interface{}) error {
	if value == nil {
		ns.ContractsServiceProtocolType, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.ContractsServiceProtocolType.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullContractsServiceProtocolType) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.ContractsServiceProtocolType), nil
}

type ContractsServiceType string

const (
	ContractsServiceTypeServiceTypeService          ContractsServiceType = "service_type_service"
	ContractsServiceTypeServiceTypeDelegatedService ContractsServiceType = "service_type_delegated_service"
)

func (e *ContractsServiceType) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = ContractsServiceType(s)
	case string:
		*e = ContractsServiceType(s)
	default:
		return fmt.Errorf("unsupported scan type for ContractsServiceType: %T", src)
	}
	return nil
}

type NullContractsServiceType struct {
	ContractsServiceType ContractsServiceType
	Valid                bool // Valid is true if ContractsServiceType is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullContractsServiceType) Scan(value interface{}) error {
	if value == nil {
		ns.ContractsServiceType, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.ContractsServiceType.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullContractsServiceType) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.ContractsServiceType), nil
}

type ContractsSignatureType string

const (
	ContractsSignatureTypeAccept ContractsSignatureType = "accept"
	ContractsSignatureTypeReject ContractsSignatureType = "reject"
	ContractsSignatureTypeRevoke ContractsSignatureType = "revoke"
)

func (e *ContractsSignatureType) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = ContractsSignatureType(s)
	case string:
		*e = ContractsSignatureType(s)
	default:
		return fmt.Errorf("unsupported scan type for ContractsSignatureType: %T", src)
	}
	return nil
}

type NullContractsSignatureType struct {
	ContractsSignatureType ContractsSignatureType
	Valid                  bool // Valid is true if ContractsSignatureType is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullContractsSignatureType) Scan(value interface{}) error {
	if value == nil {
		ns.ContractsSignatureType, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.ContractsSignatureType.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullContractsSignatureType) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.ContractsSignatureType), nil
}

type PeersRole string

const (
	PeersRoleROLEDIRECTORY PeersRole = "ROLE_DIRECTORY"
)

func (e *PeersRole) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = PeersRole(s)
	case string:
		*e = PeersRole(s)
	default:
		return fmt.Errorf("unsupported scan type for PeersRole: %T", src)
	}
	return nil
}

type NullPeersRole struct {
	PeersRole PeersRole
	Valid     bool // Valid is true if PeersRole is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullPeersRole) Scan(value interface{}) error {
	if value == nil {
		ns.PeersRole, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.PeersRole.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullPeersRole) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.PeersRole), nil
}

type ContractsContent struct {
	Hash           string
	HashAlgorithm  ContractsContentHashAlgorithm
	Iv             uuid.UUID
	GroupID        string
	ValidNotBefore pgtype.Timestamptz
	ValidNotAfter  pgtype.Timestamptz
	CreatedAt      pgtype.Timestamptz
}

type ContractsContractSignature struct {
	ContentHash           string
	SignatureType         ContractsSignatureType
	PeerID                string
	CertificateThumbprint string
	Signature             string
	SignedAt              pgtype.Timestamptz
}

type ContractsContractsWithState struct {
	Hash           string
	HashAlgorithm  ContractsContentHashAlgorithm
	Iv             uuid.UUID
	GroupID        string
	ValidNotBefore pgtype.Timestamptz
	ValidNotAfter  pgtype.Timestamptz
	CreatedAt      pgtype.Timestamptz
	State          interface{}
}

type ContractsFailedDistribution struct {
	PeerID        string
	ContentHash   string
	Signature     string
	Action        ContractsDistributionAction
	Attempts      int32
	LastAttemptAt pgtype.Timestamptz
	NextAttemptAt pgtype.Timestamptz
	Reason        string
}

type ContractsGrantsDelegatedServiceConnection struct {
	Hash                              string
	ContentHash                       string
	OutwayPeerID                      string
	DelegatorPeerID                   string
	ServicePeerID                     string
	ServiceName                       string
	PublicKeyThumbprint               string
	ServiceType                       ContractsServiceType
	ServicePublicationDelegatorPeerID pgtype.Text
}

type ContractsGrantsDelegatedServicePublication struct {
	Hash            string
	ContentHash     string
	DirectoryPeerID string
	DelegatorPeerID string
	ServicePeerID   string
	ServiceName     string
	ServiceProtocol ContractsServiceProtocolType
}

type ContractsGrantsServiceConnection struct {
	Hash                              string
	ContentHash                       string
	OutwayPeerID                      string
	ServicePeerID                     string
	ServiceName                       string
	PublicKeyThumbprint               string
	ServiceType                       ContractsServiceType
	ServicePublicationDelegatorPeerID pgtype.Text
}

type ContractsGrantsServicePublication struct {
	Hash            string
	ContentHash     string
	DirectoryPeerID string
	ServicePeerID   string
	ServiceName     string
	ServiceProtocol ContractsServiceProtocolType
}

type ContractsValidContract struct {
	Hash string
}

type ContractsWithGrantType struct {
	Iv                                  uuid.UUID
	Hash                                string
	HashAlgorithm                       ContractsContentHashAlgorithm
	GroupID                             string
	ValidNotBefore                      pgtype.Timestamptz
	ValidNotAfter                       pgtype.Timestamptz
	CreatedAt                           pgtype.Timestamptz
	HasServiceConnectionGrant           bool
	HasDelegatedServiceConnectionGrant  bool
	HasServicePublicationGrant          bool
	HasDelegatedServicePublicationGrant bool
}

type PeersCertificate struct {
	CertificateThumbprint string
	PeerID                string
	Certificate           []byte
}

type PeersPeer struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
}

type PeersPeersRole struct {
	PeerID string
	Role   PeersRole
}
